apiVersion: cluster.sneak.codes/v1alpha1
kind: LinodeCluster
metadata:
  name: {{ .Release.Name }}
  labels:
    {{- include "hello-world.labels" . | nindent 4 }}
spec: {}
---
apiVersion: source.toolkit.fluxcd.io/v1beta1
kind: HelmRepository
metadata:
  name: {{ include "hello-world.fullname" . }}
  labels:
    {{- include "hello-world.labels" . | nindent 4 }}
spec:
  interval: 24h
  url: https://gitlab.com/api/v4/projects/38926497/packages/helm/helm-charts
---
apiVersion: helm.toolkit.fluxcd.io/v2beta1
kind: HelmRelease
metadata:
  name: {{ include "hello-world.fullname" . }}
  labels:
    {{- include "hello-world.labels" . | nindent 4 }}
spec:
  interval: 1m
  releaseName: deployment
  test:
    enabled: true
  chart:
    spec:
      chart: flux-helm-releases
      sourceRef:
        name: {{ include "hello-world.fullname" . }} 
        kind: HelmRepository
  values:
############################################################################################################
    default:
      HelmRepository:
        interval: 24h
        url: https://gitlab.com/api/v4/projects/38926497/packages/helm/helm-charts 
      HelmRelease:
        interval: 1m
        install:
          createNamespace: true
          retries: 15
        kubeConfig:
          secretRef:
            key: kubeconfig
            name: {{ .Release.Name }}-kubeconfig
        chart:
          spec:
            sourceRef:
              kind: HelmRepository
              name: helm charts

    HelmRepositories:
      helm charts: {}
      external dns:
        url: https://kubernetes-sigs.github.io/external-dns/
      jetstack:
        url: https://charts.jetstack.io
      ingress nginx:
        url: https://kubernetes.github.io/ingress-nginx
      hello world:
        interval: 1m
        url: https://gitlab.com/api/v4/projects/44005062/packages/helm/hello-world

    HelmReleases:
      cluster ready:
        interval: 1m
        install:
          createNamespace: true
          remediation:
            retries: -1
        uninstall:
          disableWait: true
        chart:
          spec:
            chart: cluster-ready
        values:
          testSleep: "50"
        test:
          enable: true
      external dns:
        install:
          createNamespace: true
          remediation:
            retries: -1
        dependsOn:
          - name: cluster ready
        chart:
          spec:
            chart: external-dns
            version: "1.12.*"
            sourceRef:
              kind: HelmRepository
              name: external dns
        values:
          provider: "linode"
          sources:
            - service
          domainFilters:
            - sneak.africa
          env:
            - name: LINODE_TOKEN
              valueFrom:
                secretKeyRef:
                  name: linode-token
                  key: attribute.token
      cert manager:
        dependsOn:
          - name: cluster ready
        chart:
          spec:
            chart: cert-manager
            sourceRef:
              kind: HelmRepository
              name: jetstack
        values:
          installCRDs: true
        test:
          enable: true
      lets encrypt issuer:
        dependsOn:
          - name: cert manager
        chart:
          spec:
            chart: certmanager-acme
        values:
          ClusterIssuer: true
          Email: "admin@sneak.codes"
      nginx:
        install:
          createNamespace: true
          remediation:
            retries: -1
        dependsOn:
          - name: external dns
          - name: cert manager
        chart:
          spec:
            chart: ingress-nginx
            sourceRef:
              kind: HelmRepository
              name: ingress nginx
        values:
          controller:
            service:
              annotations:
                external-dns.alpha.kubernetes.io/hostname: "*.{{ .Release.Name }}.sneak.africa"
        test:
          enable: true
      hello world:
        dependsOn:
          - name: nginx
          - name: lets encrypt issuer
        chart:
          spec:
            chart: hello-world
            sourceRef:
              kind: HelmRepository
              name: hello world
        values:
          content:
            index.html: |
              hello from {{ .Release.Name }}!
          ingress:
            annotations:
              cert-manager.io/cluster-issuer: "lets-encrypt-issuer-certmanager-acme"
            hosts:
              - host: hello-world.{{ .Release.Name }}.sneak.africa
                paths:
                - paths: /
                  pathType: ImplementationSpecific
            tls:
              - secretName: hello-world
                hosts:
                  - hello-world.{{ .Release.Name }}.sneak.africa
  





  # dependsOn:
  #   - name: {{ include "hello-world.fullname" . }}-cluster
